Subject: Re: [RFC] [BUDFIX] 'git rm --cached <submodule>' does not stage the changed .gitmodules

From: Philippe Blain <[email-masked]>
Date: Mon, 8 Feb 2021 22:55:59 -0500

Hi Junio,

[CC'ing the original submitter of the issue]

Le 2021-02-07 à 14:30, Junio C Hamano a écrit :
> Shourya Shukla <[email-masked]> writes:
> 
>> So, my question is, do we need to fix this to make sure that the changed
>> '.gitmodules' is staged?
> 
> When "--cached" is given, the user is asking the module to be
> removed ONLY from the index, without removing it from the working
> tree, no?
> 
> So I think ".gitmodules" in the working tree should not be touched
> at all.
> 
> Removing the entry for the module from the ".gitmodules" registered
> in the index, when a submodule registered in the index [IS REMOVED], might be
> desirable, and what you say here
> 
>> And its entry is not removed from the file. What should be done about
>> this? I would appreciate your opinions.
> 
> may be related to it.

This seems to be what the original email [1] was about, i.e. Javier seemed to
expect that the changes to ".gitmodules" should be staged but the worktree version
of the file untouched. This would be more in line (I think) with the current
behaviour of 'git rm <submodule>', which removes the submodule worktree and
relevant sections of '.gitmodules' in some cases since 95c16418f0 (rm: delete .gitmodules
entry of submodules removed from the work tree, 2013-08-06).

> 
> But I doubt it is a good idea to let "git rm" be the one touching
> ".gitmodules" either in the index or in the working tree for that to
> happen.
> 

That's already the behaviour, at least for 'git rm <submodule>', see
the commit cited above, and the whole topic that introduced it,
b02f5aeda6 (Merge branch 'jl/submodule-mv', 2013-09-09) that added
some knowledge of '.gitmodules' to 'git mv' and 'git rm'.

> The reason I am hesitant to teach anything about ".gitmodules" to
> the basic level tools like "add", "rm" is because I consider, while
> the "gitlink" design that allows the tip-commit from a submodule in
> the superproject is a good thing to be done at the structural level
> in the core part of Git, administrative information stored in the
> ".gitmodules" is not part of pure "Git" and alternative designs on
> top of the core part of Git that uses different strategy other than
> what we have are possible and they could even turn out to be better
> than what we currently have.  In other words, I have this suspicion
> that the ".gitmodules" based submodule handling we currently have,
> done using "git submodule" command, should not be the only and final
> form of submodule support Git would offer.
> 
> That leads me to think that anything that touch ".gitmodules" should
> be done with "git submodule" suite of commands, not by the low level
> "add", "rm", etc.  Such a separation of concern would allow a new
> "git submodule2" design that may be radically different from the
> current ".gitmodules" one to be introduced, possibly even replacing,
> or living next to each other, the current "git submodule" together
> with ".gitmodules" file, without affecting the low-level "add", "rm"
> tools at all.
> 
> So from that point of view, if we were to fix the system, it may be
> preferrable to make "git rm [--options] <submodule>" only about the
> submodule in the working tree and/or the index, without touching
> ".gitmodules" at all, and let "git submodule rm [--cached]
> <submodule>" be the interface on top.  The implementation of "git
> submodule rm [--cached]" may use "git rm [--cached]" internally as a
> building block to deal with the index and/or the working tree, but
> the info kept in ".gitmodules" for administrative reasons should be
> dealt within "git submodule" without exposing any such policy to the
> lower level tools like "git rm" and "git add".

I personnally think this is not the direction I wish Git would go in.
Submodules are hard, and part of the reason they are disliked so much
is because they were not initially well integrated in the rest of the system,
and this "belief" has stuck despite major efforts e.g. adding '--recurse-submodules'
and flags and 'submodule.recurse' configs for several commands.

So I would really prefer for "core" Git commands -- as you call them, for me all
of the porcelain commands are on the same level -- to be more intelligent
submodule-wise, like in this case, adding functionality to 'git rm' instead
of adding another 'git submdule' subcommand.

Cheers,

Philippe.

[1] https://lore.kernel.org/git/[email-masked]/T/#u